class ChangesetObserver < ActiveRecord::Observer

    def after_create(changeset)
        if Setting.notified_events.include?('changeset_added')
            if Rails::VERSION::MAJOR < 3
                Mailer.deliver_changeset_added(changeset)
            else
                Mailer.changeset_added(changeset).deliver
            end
        end
    end

end
