class VersionObserver < ActiveRecord::Observer

    def after_create(version)
        if version.closed?
            VersionClosures.create(:version => version)

            if Setting.notified_events.include?('version_closed')
                if Rails::VERSION::MAJOR < 3
                    Mailer.deliver_version_closed(version)
                else
                    Mailer.version_closed(version).deliver
                end
            end
        end
    end

    def after_update(version)
        if version.closed?
            unless VersionClosures.find_by_version_id(version.id)
                VersionClosures.create(:version => version)

                if Setting.notified_events.include?('version_closed')
                    if Rails::VERSION::MAJOR < 3
                        Mailer.deliver_version_closed(version)
                    else
                        Mailer.version_closed(version).deliver
                    end
                end
            end
        end
    end

end
