require_dependency 'issue'

module IssueSubscriptionPatch

    def self.included(base)
        base.send(:include, InstanceMethods)
        base.class_eval do
            unloadable

            alias_method_chain :notified_users, :subscribers
        end
    end

    module InstanceMethods

        def notified_users_with_subscribers
            notified = notified_users_without_subscribers

            if project.module_enabled?(:subscription)
                subscribers          = ProjectSubscriber.find_all_by_project_id(project.id)
                notified_subscribers = subscribers.select{ |subscriber| subscriber.subscribed_to?(:new_issues) &&
                                                                        subscriber.user.allowed_to?(:subscribe_to_project, project) &&
                                                                        visible?(subscriber.user)
                                                         }.collect(&:user)
                unless notified_subscribers.empty?
                    notified += notified_subscribers
                    notified.uniq!
                end
            end

            notified
        end

    end

end
