module NotifiableSubscriptionPatch

    def self.included(base)
        base.extend(ClassMethods)
        base.class_eval do
            unloadable

            class << self
                alias_method_chain :all, :subscription
            end
        end
    end

    module ClassMethods

        def all_with_subscription
            notifications = all_without_subscription

            notifications << Redmine::Notifiable.new('version_closed')
            notifications << Redmine::Notifiable.new('changeset_added')
            notifications << Redmine::Notifiable.new('board_added')

            notifications
        end

    end

end
