require_dependency 'project'

module ProjectSubscriptionPatch

    def self.included(base)
        base.send(:include, InstanceMethods)
        base.class_eval do
            unloadable
        end
    end

    module InstanceMethods

        def subscribables
            @subscribables ||= begin
                subscriptions = []

                subscriptions << :news          if module_enabled?('news') &&
                                                  (Setting.notified_events.include?('news_added') || Setting.notified_events.include?('news_comment_added'))
                subscriptions << :releases      if Setting.notified_events.include?('version_closed')
                subscriptions << :files         if module_enabled?('files') && Setting.notified_events.include?('file_added')
                subscriptions << :wiki_pages    if module_enabled?('wiki') && Setting.notified_events.include?('wiki_content_added')
                subscriptions << :repository    if module_enabled?('repository') && Setting.notified_events.include?('changeset_added')
                subscriptions << :new_issues    if module_enabled?('issue_tracking') && Setting.notified_events.include?('issue_added')
                subscriptions << :closed_issues if module_enabled?('issue_tracking') && Setting.notified_events.include?('issue_updated')
                subscriptions << :forums        if module_enabled?('boards') && Setting.notified_events.include?('board_added')

                subscriptions
            end
        end

    end

end
